declare type ConsoleLogger = (...args: unknown[]) => void;
declare type Console = {
    log: ConsoleLogger;
    warn: ConsoleLogger;
    error: ConsoleLogger;
    clear: () => void;
};
declare type NoteOptions = {
    id?: string;
};
declare class MosfezXenSynth {
    private _totalVoices;
    private _voiceAllocator;
    private _voicesState;
    private _rootHz;
    private _envRelease;
    console?: Console;
    constructor();
    private resetVoiceState;
    get rootHz(): number;
    set rootHz(hz: number);
    setNote(midi: number, options?: NoteOptions): void;
    stopNote(midi: number): void;
    stopNote(id: string): void;
}

export { MosfezXenSynth, NoteOptions };
